var global_document_url = "";
var global_vid_mate_video_id = "";

var htmlEnDeCode = (function() {
    var charToEntityRegex,
        entityToCharRegex,
        charToEntity,
        entityToChar;

    function resetCharacterEntities() {
        charToEntity = {};
        entityToChar = {};
        // add the default set
        addCharacterEntities({
            '&amp;'     :   '&',
            '&gt;'      :   '>',
            '&lt;'      :   '<',
            '&quot;'    :   '"',
            '&#39;'     :   "'"
        });
    }

    function addCharacterEntities(newEntities) {
        var charKeys = [],
            entityKeys = [],
            key, echar;
        for (key in newEntities) {
            echar = newEntities[key];
            entityToChar[key] = echar;
            charToEntity[echar] = key;
            charKeys.push(echar);
            entityKeys.push(key);
        }
        charToEntityRegex = new RegExp('(' + charKeys.join('|') + ')', 'g');
        entityToCharRegex = new RegExp('(' + entityKeys.join('|') + '|&#[0-9]{1,5};' + ')', 'g');
    }

    function htmlEncode(value){
        var htmlEncodeReplaceFn = function(match, capture) {
            return charToEntity[capture];
        };

        return (!value) ? value : String(value).replace(charToEntityRegex, htmlEncodeReplaceFn);
    }

    function htmlDecode(value) {
        var htmlDecodeReplaceFn = function(match, capture) {
            return (capture in entityToChar) ? entityToChar[capture] : String.fromCharCode(parseInt(capture.substr(2), 10));
        };

        return (!value) ? value : String(value).replace(entityToCharRegex, htmlDecodeReplaceFn);
    }

    resetCharacterEntities();

    return {
        htmlEncode: htmlEncode,
        htmlDecode: htmlDecode
    };
})();

function vid_mate_get_video_id(url) {
	var vid_mate_url = url || document.URL;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}

	//http://dailytube.in/video_play.php?id=3719969d7533
	if(-1 == vid_mate_url.indexOf("video_play.php"))
	{
		return null;
	}
	
	var video_id = null;
	video_id = vid_mate_get_parameter(vid_mate_url, "id");
	return video_id;
}

function vid_mate_check(url) {
	if (vid_mate_get_video_id(url) == null) {
		vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}
	
function vid_mate_video_analytics(vm_content) {
    vid_mate_setParseMsg(60, 90, 'Analytics Video Info');

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "dailytube";
	var tmp_video_file = new vid_mate_video_file();
	rtn_video.id = global_vid_mate_video_id;

	var tmp_content = vm_content;

	var videoTitle = "mp4";
	var tmp_re = new RegExp("<title>(.+?)</title>");
	if (tmp_re.test(tmp_content)) {
		var tmp_m = tmp_content.match(tmp_re);
		videoTitle = tmp_m[1];
	}

	var videoImg = "";
	var tmp_video_id = cutstr(vm_content, "img src='http://vbcdn.com/cdn/download/", ".jpg");
	if (tmp_video_id) 
	{
		videoImg = "http://vbcdn.com/cdn/download/" + tmp_video_id + ".jpg";
	}
	
	if(!tmp_video_id)
	{
		vid_mate_error_default('dailytube -1');
		return null;
	}
	
	var videoUrl = "";
	if (tmp_video_id) 
	{   
		//videoUrl = "https://dl.veblr.com/VideoDownload/CDN/" + tmp_video_id + ".mp4";
		videoUrl = "http://vbcdn.com/cdn/download/" + tmp_video_id + ".mp4";
	}
	
	if("" == videoUrl)
	{
		videoUrl = cutstr(vm_content, "<div class=\"download_button\"><a href=\"", "\"");
	}

	if("" == videoUrl)
	{
		vid_mate_error_default('dailytube 1');
		return null;
	}

	videoTitle = htmlEnDeCode.htmlDecode(videoTitle);
	rtn_video.title = videoTitle;
	rtn_video.url = global_document_url;
	rtn_video.picture_default = videoImg;
	rtn_video.picture_big = videoImg;

	tmp_video_file.url = videoUrl;
	tmp_video_file.f_id = rtn_video.id;
	var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
	tmp_video_file.format = tmp_format;
	tmp_video_file.title = tmp_format;
    tmp_video_file.referer = "http://mrpopat.in";

	rtn_video.files.push(tmp_video_file);
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info(url) 
{
	if(null == url || undefined == url || 0 == url.length)
	{
		return vid_mate_get_video_info_on_blank(document.URL);
	}
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	var vid_mate_video_id = vid_mate_get_video_id(url);
	if(null == vid_mate_video_id)
	{
		return;
	}
	global_vid_mate_video_id = vid_mate_video_id;
	vid_mate_setParseMsg(20, 60, 'Get Video Info.... ..');

	//var url = "http://mrpopat.in/embed.php?id="+vid_mate_video_id+"&wth=320&hgt=168&autoplay=false";
	//var referer = url;
	var referer = "http://mrpopat.in";
	var cookie = "";
	var userAgent = "Mozilla/5.0 (Android; Mobile; rv:15.0) Gecko/13.0 firefox/16.0";
	var method = "get";
	var data = "";
	vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}

function rcutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p2 = content.indexOf(suffix);
	if(-1 == p2)
	{
		return "";
	}

	content = content.substr(0, p2);

	var p1 = content.lastIndexOf(prefix);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1 + prefix_len , p2);
}

